<?php

namespace App\Presenters;

use App\Model\AssignmentManager;
use App\Model\Constants;
use App\Model\MailManager;
use App\Model\TeamManager;

/**
 * Presenter class to handle requests to page with assignments without mentors management
 */
class AssignmentsWithoutMentorManagementPresenter extends BasePresenter {

    public AssignmentManager $assignmentManager;

    public function __construct(AssignmentManager $assignmentManager) {
        parent::__construct();

        $this->assignmentManager = $assignmentManager;
    }

    public function renderDefault() {

        $this->template->assignments = $this->assignmentManager->getAssignmentsWithoutMentor()
            ->where('hidden != ?', Constants::$ASSIGNMENT_VISIBILITY_HIDDEN);
    }

}