<?php
/**
 * TEST: Test for generating random string
 * @testCase
 */

use App\Model\Utils;
use Tester\Assert;

require __DIR__ . '/bootstrap.php';

class GenerateRandomStringTest extends Tester\TestCase
{


    /**
     * @test
     */
    public function testRandomNotContainst_1() {
        $permittedChars = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
        $length = 64;
        $rnd = Utils::randomString($permittedChars,$length);
        Assert::notContains('#',$rnd,"Random string: ".$rnd." contains invalid character '#'!\n");
    }

    /**
     * @test
     */
    public function testRandomLength64() {
        $permittedChars = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
        $length = 64;
        $rnd = Utils::randomString($permittedChars,$length);
        Assert::same($length,strlen($rnd),"Random string: ".$rnd." does not have length:".$length."!\n");
    }

    /**
     * @test
     */
    public function testRandomLengthCNT_0() {
        $permittedChars = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
        $length = 0;
        $rnd = Utils::randomString($permittedChars,$length);
        Assert::same($length,strlen($rnd),"Random string: ".$rnd." does not have length:".$length."!\n");
    }

    /**
     * @test
     */
    public function testRandomLengthEMPTY_CNT_0() {
        $permittedChars = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
        $length = 0;
        $rnd = Utils::randomString($permittedChars,$length);
        Assert::same("",$rnd,"Random string: ".$rnd." is not empty!\n");
    }

    /**
     * @test
     */
    public function testRandomOnlyNumbers() {
        $permittedChars = '0123456789';
        $length = 25;
        $rnd = Utils::randomString($permittedChars,$length);
        Assert::match('#[0-9]+#',$rnd,"Random string: ".$rnd." does not contains only numbers!\n");
    }

    /**
     * @test
     */
    public function testRandomOnlyAlpha() {
        $permittedChars = 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
        $length = 180;
        $rnd = Utils::randomString($permittedChars,$length);
        Assert::match('#[a-zA-Z]+#',$rnd,"Random string: ".$rnd." does not contains only numbers!\n");
    }




}

(new GenerateRandomStringTest())->run();
