<?php
/**
 * TEST: Test actions with other project links
 * @testCase
 */

use App\Model\Utils;
use Tester\Assert;

require __DIR__ . '/bootstrap.php';

class TransformProjectLinksTest extends Tester\TestCase
{

	
	/**
     * @test
     */
	public function testUrlCorrect() {
        $otherUrls = "FB;https://www.facebook.com\nGOOGLE;https://www.google.com\nREDMINE;https://www.redmine.com";
        $expected = ["FB" => "https://www.facebook.com",
            "GOOGLE"=>"https://www.google.com",
            "REDMINE"=>"https://www.redmine.com"];
        $actual = Utils::transformProjectLinksFromLineToArray($otherUrls);
        Assert::equal($expected,$actual,"Urls: ".$otherUrls." are not in valid format!\n");
    }

    /**
     * @test
     */
    public function testUrlBlank() {
        $otherUrls = '';
        $expected = [];
        $actual = Utils::transformProjectLinksFromLineToArray($otherUrls);
        Assert::equal($expected,$actual,"Urls: ".$otherUrls." are not in valid format!\n");
    }

}

(new TransformProjectLinksTest())->run();
